/**
  Copyright (C) 2012 The University of Rostock.
 
  Written by:  Niels Grewe
  Created: 17.02.2012
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either
  version 3 of the License, or (at your option) any later version.

  You should have received a copy of the GNU General Public
  License along with this program; see the file COPYING.
  If not, write to the Free Software Foundation,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

 */
package de.uni_rostock.goodod.owl;

import java.util.Map;
import java.util.HashMap;

import org.semanticweb.owlapi.model.*;
/**
 * @author Niels Grewe
 * Tracks autogenerated names for class expressions. 
 */
public class ClassExpressionNameProvider {
	private final Map<OWLClassExpression,IRI> classNameMap;
	private int generationCount;
	private static ClassExpressionNameProvider sharedProvider = new ClassExpressionNameProvider();
	final static String autogenerationURI = "http://www.iph.uni-rostock.de/goodod/autogen.owl#AutogeneratedClass";

	public ClassExpressionNameProvider()
	{
		classNameMap = new HashMap<OWLClassExpression,IRI>();
		
	}
	
	public static ClassExpressionNameProvider getSharedProvider()
	{
		return sharedProvider;
	}
	
	public synchronized IRI IRIForClassExpression(OWLClassExpression ce)
	{
		IRI theIRI = classNameMap.get(ce);
		if (null == theIRI)
		{
			theIRI = IRI.create(autogenerationURI + generationCount++);
			classNameMap.put(ce, theIRI);
		}
		return theIRI;
	}
}
